#include<cstdio>
#include<cmath>
#include<cstdlib>
#include<sstream>
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<ctime>
using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()
///////////////////////////////////////////
#define mx 131072
#define NONULL 1

typedef struct {int l,m,r,left,right,up,down,slope;long long vol;} node;

class nlogn
{public:

//node h[mx*2];
node*h;

nlogn(void)
  {
  h=(node*)malloc(sizeof(node)*mx*2);
  }

int build(int where,int l,int r)
  {
  h[where].l=l;
  h[where].r=r;
  h[where].m=(l+r)/2;
  h[where].slope=0;
  h[where].vol=r-l+1;
  h[where].left=l%2;
  h[where].right=1-r%2;
  if(where>=mx)
    {h[where].up=1-l%2;
    h[where].down=l%2;
    if(l%2==0)h[where].slope=1;
    if(l%2==1)h[where].slope=-1;
    return 0;}
  build(where*2,l,h[where].m);
  build(where*2+1,h[where].m+1,r);
  h[where].up=h[where*2].up+h[where*2+1].up;
  h[where].down=h[where*2].down+h[where*2+1].down;
  return 0;
  }

int height(int where,int l,int r,int n)
  {
  if(h[where].slope)return h[where].left+(n-h[where].l)*h[where].slope;
  if(n==l)return h[where].left;
  if(n==r+1)return h[where].right;
  if(n<=h[where].m)return height(where*2,l,h[where].m,n);
  if(n>h[where].m)return height(where*2+1,h[where].m+1,r,n);
  }

int seekleftdown(int where,int l,int r,int n)
  {
  if(h[where].slope==1)return 0;
  if(h[where].slope==-1)
    if(n<=r-l+1)
      return r+1-n;
    else return -(r-l+1);
  if(l==h[where].l && h[where].r==r)
    if(n>h[where].down)
      return -h[where].down;
  if(r<=h[where].m)return seekleftdown(where*2,l,r,n);
  if(l>h[where].m)return seekleftdown(where*2+1,l,r,n);
  int c1=0,c2=0;
  c1=seekleftdown(where*2+1,h[where].m+1,r,n);
  if(c1>0)return c1;
  c2=seekleftdown(where*2,l,h[where].m,n+c1);
  if(c2>0)return c2;
  return c1+c2;
  }

int seekleftup(int where,int l,int r,int n)
  {
  if(h[where].slope==-1)return 0;
  if(h[where].slope==1)
    if(n<=(r-l+1))
      return r+1-n;
    else return -(r-l+1);
  if(l==h[where].l && h[where].r==r)
    if(n>h[where].up)
      return -h[where].up;
  if(r<=h[where].m)return seekleftup(where*2,l,r,n);
  if(l>h[where].m)return seekleftup(where*2+1,l,r,n);
  int c1=0,c2=0;
  c1=seekleftup(where*2+1,h[where].m+1,r,n);
  if(c1>0)return c1;
  c2=seekleftup(where*2,l,h[where].m,n+c1);
  if(c2>0)return c2;
  return c1+c2;
  }

int seekrightdown(int where,int l,int r,int n)
  {
  if(h[where].slope==1)return 0;
  if(h[where].slope==-1)
    if(n<=r-l+1)
      return l+n;
    else return -(r-l+1);
  if(l==h[where].l && h[where].r==r)
    if(n>h[where].down)
      return -h[where].down;
  if(r<=h[where].m)return seekrightdown(where*2,l,r,n);
  if(l>h[where].m)return seekrightdown(where*2+1,l,r,n);
  int c1=0,c2=0;
  c1=seekrightdown(where*2,l,h[where].m,n);
  if(c1>0)return c1;
  c2=seekrightdown(where*2+1,h[where].m+1,r,n+c1);
  if(c2>0)return c2;
  return c1+c2;
  }

int seekrightup(int where,int l,int r,int n)
  {
  if(h[where].slope==-1)return 0;
  if(h[where].slope==1)
    if(n<=r-l+1)
      return l+n;
    else return -(r-l+1);
  if(l==h[where].l && h[where].r==r)
    if(n>h[where].up)
      return -h[where].up;
  if(r<=h[where].m)return seekrightup(where*2,l,r,n);
  if(l>h[where].m)return seekrightup(where*2+1,l,r,n);
  int c1=0,c2=0;
  c1=seekrightup(where*2,l,h[where].m,n);
  if(c1>0)return c1;
  c2=seekrightup(where*2+1,h[where].m+1,r,n+c1);
  if(c2>0)return c2;
  return c1+c2;
  }


int update(int where,int l,int r,int slope,int left)
  {
  if(slope==0)
    {
    if(h[where].slope)h[where].slope=0;
    else 
      {
      update(where*2,l,h[where].m,slope,-1);
      update(where*2+1,h[where].m+1,r,slope,-1);
      }
    return 0;
    }
  if(l==h[where].l && h[where].r==r)
    {
    h[where].left=left;
    h[where].right=left+(r-l+1)*slope;
    h[where].up=h[where].down=0;
    if(slope==1)h[where].up=(r-l+1);
    else h[where].down=(r-l+1);
    update(where,l,r,0,-1);
    h[where].slope=slope;
    h[where].vol=(long long)(r-l+1)*(long long)(h[where].left+h[where].right);
    return 0;
    }
  if(h[where].slope)
    {
    h[where*2].slope=h[where].slope;
    h[where*2].left=h[where].left;
    h[where*2].right=(h[where].left+h[where].right)/2;
    h[where*2].up=(h[where].slope==1)*(h[where].m+1-h[where].l);
    h[where*2].down=(h[where].slope==-1)*(h[where].m+1-h[where].l);
    h[where*2].vol=(long long)(h[where*2].left+h[where*2].right)*(long long)(h[where*2].r-h[where*2].l+1);
    h[where*2+1].slope=h[where].slope;
    h[where*2+1].left=(h[where].left+h[where].right)/2;
    h[where*2+1].right=h[where].right;
    h[where*2+1].up=(h[where].slope==1)*(h[where].r-h[where].m);
    h[where*2+1].down=(h[where].slope==-1)*(h[where].r-h[where].m);
    h[where*2+1].vol=(long long)(h[where*2+1].left+h[where*2+1].right)*(long long)(h[where*2+1].r-h[where*2+1].l+1);
    h[where].slope=0;
    }
  if(r<=h[where].m)update(where*2,l,r,slope,left);
  if(l> h[where].m)update(where*2+1,l,r,slope,left);
  if(l<=h[where].m && r>h[where].m)
    {
    update(where*2,l,h[where].m,slope,left);
    update(where*2+1,h[where].m+1,r,slope,left+slope*(h[where].m+1-l));
    }
    
  if(h[where*2].slope==h[where*2+1].slope && h[where*2].slope!=0)if(h[where*2].r==h[where*2+1].l)
    {
    h[where].slope=h[where*2].slope;
    h[where*2].slope=h[where*2+1].slope=0;
    }
  h[where].left=h[where*2].left;
  h[where].right=h[where*2+1].right;
  h[where].up=h[where*2].up+h[where*2+1].up;
  h[where].down=h[where*2].down+h[where*2+1].down;
  h[where].vol=h[where*2].vol+h[where*2+1].vol;
  return 0;
  }

long long volume(int where,int l,int r)
  {
  if(h[where].slope)
    return (long long)((h[where].left+(l-h[where].l)*h[where].slope)*2+(r-l+1)*h[where].slope)*(long long)(r-l+1);
  if(l==h[where].l && h[where].r==r)return h[where].vol;
  if(r<=h[where].m)return volume(where*2,l,r);
  if(l>h[where].m)return volume(where*2+1,l,r);
  return volume(where*2,l,h[where].m)+volume(where*2+1,h[where].m+1,r);
  }

string profile(int where,int l,int r)
  {
  if(h[where].slope)
    {
    string e1;
    int q1;
    for(q1=0;q1<h[where].down;q1++)e1.pb('d');
    for(q1=0;q1<h[where].up;q1++)e1.pb('u');
    return e1;
    }
  else if(r<=h[where].m)return profile(where*2,l,r);
  else if(l>h[where].m)return profile(where*2+1,l,r);
  else return profile(where*2,l,h[where].m)+profile(where*2+1,h[where].m+1,r);
  }
};

class square
{public:
VI ss;
int n;
int build(int len)
  {
  int q1;
  ss.clear();
  n=len;
  ss.resize(n+1);
  for(q1=0;q1<ss.sz;q1++)ss[q1]=q1%2;
  return 0;
  }

int height(int x)
  {
  return ss[x];
  }

long long volume(int a,int b)
  {
  long long ans=0;
  int q1;
  for(q1=a+1;q1<=b-1;q1++)ans+=ss[q1]*2;
  ans+=ss[a]+ss[b];
  return ans;
  }

int update(int x,int h)
  {
  int q1;
  ss[x]=h;
  for(q1=x-1;q1>=0;q1--)
    {
    if(ss[q1]>ss[q1+1]+1)ss[q1]=ss[q1+1]+1;
    else if(ss[q1]<ss[q1+1]-1)ss[q1]=ss[q1+1]-1;
    else break;
    }
  for(q1=x+1;q1<=n;q1++)
    {
    if(ss[q1]>ss[q1-1]+1)ss[q1]=ss[q1-1]+1;
    else if(ss[q1]<ss[q1-1]-1)ss[q1]=ss[q1-1]-1;
    else break;
    }
  return 0;
  }
  
string profile(void)
  {
  int q1;
  string a;
  for(q1=1;q1<=n;q1++)
    {if(ss[q1]>ss[q1-1])a.pb('u');
    else a.pb('d');}
  return a;
  }

int seekleftup(int x,int n)
  {
  int q1=x-1,c1=0;
  while(1)
    {if(ss[q1]<ss[q1+1])c1++;
    if(c1==n)break;
    q1--;}
  return q1;
  }
int seekrightup(int x,int n)
  {
  int q1=x+1,c1=0;
  while(1)
    {if(ss[q1]>ss[q1-1])c1++;
    if(c1==n)break;
    q1++;}
  return q1;
  }
int seekleftdown(int x,int n)
  {
  int q1=x-1,c1=0;
  while(1)
    {if(ss[q1]>ss[q1+1])c1++;
    if(c1==n)break;
    q1--;}
  return q1;
  }
int seekrightdown(int x,int n)
  {
  int q1=x+1,c1=0;
  while(1)
    {if(ss[q1]<ss[q1-1])c1++;
    if(c1==n)break;
    q1++;}
  return q1;
  }
};



class solve
{public:

nlogn fast;
square slow;
vector < VI > input;
int c,m;
int debug,fs,sl,err;

int error(string a,int c1,int c2)
  {
  if(debug)printf("%s  -  fast:  %d     slow:  %d\n",a.cs,c1,c2);
  err=1;
  return 0;
  }

VS doit(vector < VI > a,int type)
  {
  debug=sl=fs=err=0;
  if(type&1)debug=1;
  if(type&2)sl=1;
  if(type&4)fs=1;
  int c1,c2,c3,c4,c5,c6,cl,cr,q1;
  VS res;
  long long ans;
  m=a[0][0];
  c=a[0][1];
  input.clear();
  for(q1=1;q1<a.sz;q1++)input.pb(a[q1]);
  if(fs)fast.build(1,0,mx-1);
  if(sl)slow.build(m);
  for(q1=0;q1<c;q1++)
    {
    c1=input[q1][0];
    c2=input[q1][1];
    c3=input[q1][2];
    string e1;
   // printf("%d\n",q1);
    if(debug)e1=profile();
    //if(debug)printf("%s\n",e1.cs);
    if(debug)if(err)
      {
      VS aa;
      aa.pb("ERROR");
      return aa;
      }
    if(c1==1) 
      {
      c4=height(c2);
      if(c4==c3)continue;
      if(fs)if(c4>c3)
        {
        c5=c4-c3;
        cl=seekleftup(c2,c5/2);
        cr=seekrightdown(c2,c5/2);
        c6=height(cl);
        update(1,cl,c2-1,-1,c6);
        update(1,c2,cr-1,1,c3);
        }
      if(fs)if(c4<c3)
        {
        c5=c3-c4;
        cl=seekleftdown(c2,c5/2);
        cr=seekrightup(c2,c5/2);
        c6=height(cl);
        update(1,cl,c2-1,1,c6);
        update(1,c2,cr-1,-1,c3);
        }
      if(sl)update2(c2,c3);
      }
    if(c1==2)
      {
      char d[100];
      ans=volume(c2,c3);
      if(ans%2)sprintf(d,"%lld.5",ans/2);
      else sprintf(d,"%lld",ans/2);
      res.pb(d);
      }
    }
  return res;
  }

int height(int x)
  {
  int c1=0,c2=0;
  if(fs)c1=fast.height(1,0,mx-1,x);
  if(sl)c2=slow.height(x);
  if(fs&&sl)if(c1!=c2)if(debug)error("height",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }

int update(int where,int l,int r,int slope,int left)
  {
  fast.update(where,l,r,slope,left);
  return 0;
  }

int update2(int x,int h)
  {
  slow.update(x,h);
  return 0;
  }

long long volume(int a,int b)
  {
  long long c1=0,c2=0;
  if(fs)c1=fast.volume(1,a,b-1);
  if(sl)c2=slow.volume(a,b);
  if(fs&&sl)if(c1!=c2)if(debug)error("volume",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }

int seekleftup(int x,int n)
  {
  int c1=0,c2=0;
  if(fs)c1=fast.seekleftup(1,0,x-1,n);
  if(sl)c2=slow.seekleftup(x,n);
  if(fs&&sl)if(c1!=c2)if(debug)error("seekleftup",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }

int seekleftdown(int x,int n)
  {
  int c1=0,c2=0;
  if(fs)c1=fast.seekleftdown(1,0,x-1,n);
  if(sl)c2=slow.seekleftdown(x,n);
  if(fs&&sl)if(c1!=c2)if(debug)error("seekleftdown",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }
  
int seekrightup(int x,int n)
  {
  int c1=0,c2=0;
  if(fs)c1=fast.seekrightup(1,x,mx-1,n);
  if(sl)c2=slow.seekrightup(x,n);
  if(fs&&sl)if(c1!=c2)if(debug)error("seekrightup",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }
  
int seekrightdown(int x,int n)
  {
  int c1=0,c2=0;
  if(fs)c1=fast.seekrightdown(1,x,mx-1,n);
  if(sl)c2=slow.seekrightdown(x,n);
  if(fs&&sl)if(c1!=c2)if(debug)error("seekrightdown",c1,c2);
  if(fs)return c1;
  if(sl)return c2;
  }

string profile(void)
  {
  string c1,c2;
  if(debug==0)return "";
  if(fs)c1=fast.profile(1,0,m-1);
  if(sl)c2=slow.profile();
  if(fs&&sl)if(c1!=c2)if(debug)printf("profile\n  fast:  %s\n  slow:  %s\n",c1.cs,c2.cs);
  if(fs)return c1;
  if(sl)return c2;
  }

};

solve solver;

vector < pair < vector < VI > , VS > > tests;


int solveinputfile(string a)
  {
  vector < VI > input;
  FILE*fn;
  fn=fopen(a.cs,"r");
  int m,c;
  fscanf(fn,"%d %d",&m,&c);
  VI e1;
  e1.pb(m);
  e1.pb(c);
  input.pb(e1);
  int q1,c1,c2,c3;
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%d %d %d",&c1,&c2,&c3);
    e1.clear();
    e1.pb(c1);
    e1.pb(c2);
    e1.pb(c3);
    input.pb(e1);}
  VS ans=solver.doit(input,4);
  for(q1=0;q1<ans.sz;q1++)
    {
    printf("%s\n",ans[q1].cs);
    }
  fclose(fn);
  return 0;
  }


long long rnd(long long a,long long b)
  {
  long long c1=b-a+1;
  long long c2=(long long)rand()*(long long)rand()*(long long)rand()*(long long)rand()+(long long)rand()*(long long)rand()*(long long)rand()+(long long)rand();
  if(c2<0)c2=-c2;
  c2%=c1;
  return a+c2;
  }

vector < VI > test_fast(int m,int upd,int query)
  {
  vector < VI > test;
  VI e1;
  int c=upd+query;
  e1.pb(m);
  e1.pb(upd+query);
  test.pb(e1);
  int q1,q2,q3,c1,c2,c3,c4,c5,c6,cr,cl;
  long long ans;
  VI rr;
  for(q1=0;q1<upd;q1++)rr.pb(1);
  for(q1=0;q1<query;q1++)rr.pb(2);
  for(q1=0;q1<10;q1++)random_shuffle(ALL(rr));
  nlogn solver;
  solver.build(1,0,mx-1);
  for(q1=0;q1<c;q1++)
    {
    e1.clear();
    e1.pb(rr[q1]);
    if(rr[q1]==1)
      {
      beg2:
      c1=rnd(0,m/2);
      c1+=rnd(0,m/2);
      if(c1<=1)c1=2;
      if(c1>=m-1)c1=m-2;
      c2=solver.height(1,0,mx-1,c1);
      if(c1<=m/2)c3=c1;
      else c3=m-c1;
      c4=c1%2;
      int upp=0;
      long long cc1=rnd(0,(long long)(c2-c4+1)*(long long)(c2-c4+1)+(long long)(c3-c2+1)*(long long)(c3-c2+1));
      if(cc1>(long long)(c2-c4+1)*(long long)(c2-c4+1))upp=1;
      if(upp)c6=c3-c2;else c6=c2-c4;
      c5=rnd(0,c6);
      c5+=rnd(0,c6);
      c5-=c6;
      if(c5<0)c5=-c5;
      c5-=c5%2;
      if(c5==0)if(NONULL)goto beg2;
      if(upp)c5=c2+c5;else c5=c2-c5;
      e1.pb(c1);
      e1.pb(c5);

      c4=c2;
      c2=c1;
      c3=c5;
      
      if(c4==c3)goto after;
      if(c4>c3)
        {
        c5=c4-c3;
        cl=solver.seekleftup(1,0,c2-1,c5/2);
        cr=solver.seekrightdown(1,c2,mx-1,c5/2);
        c6=solver.height(1,0,mx-1,cl);
        solver.update(1,cl,c2-1,-1,c6);
        solver.update(1,c2,cr-1,1,c3);
        }
      if(c4<c3)
        {
        c5=c3-c4;
        cl=solver.seekleftdown(1,0,c2-1,c5/2);
        cr=solver.seekrightup(1,c2,mx-1,c5/2);
        c6=solver.height(1,0,mx-1,cl);
        solver.update(1,cl,c2-1,1,c6);
        solver.update(1,c2,cr-1,-1,c3);
        }
      after:;
      }
    if(rr[q1]==2)
      {
      c1=rnd(0,m-1);
      c2=rnd(0,c1);
      c3=rnd(c1+1,m);
      e1.pb(c2);
      e1.pb(c3);
      } 
    test.pb(e1);
    }
  return test;
  }

vector < VI > test_slow(int m,int upd,int query)
  {
  vector < VI > test;
  VI e1;
  int c=upd+query;
  e1.pb(m);
  e1.pb(upd+query);
  test.pb(e1);
  int q1,q2,q3,c1,c2,c3,c4,c5,c6,cr,cl;
  long long ans;
  VI rr;
  for(q1=0;q1<upd;q1++)rr.pb(1);
  for(q1=0;q1<query;q1++)rr.pb(2);
  for(q1=0;q1<10;q1++)random_shuffle(ALL(rr));
  square solver;
  solver.build(m);
  for(q1=0;q1<c;q1++)
    {
    e1.clear();
    e1.pb(rr[q1]);
    if(rr[q1]==1)
      {
      beg1:
      c1=rnd(0,m/2);
      c1+=rnd(0,m/2);
      if(c1<=1)c1=2;
      if(c1>=m-1)c1=m-2;
      c2=solver.height(c1);
      if(c1<=m/2)c3=c1;
      else c3=m-c1;
      c4=c1%2;
      int upp=0;
      long long cc1=rnd(0,(long long)(c2-c4+1)*(long long)(c2-c4+1)+(long long)(c3-c2+1)*(long long)(c3-c2+1));
      if(cc1>(long long)(c2-c4+1)*(long long)(c2-c4+1))upp=1;
      if(upp)c6=c3-c2;else c6=c2-c4;
      c5=rnd(0,c6);
      c5+=rnd(0,c6);
      c5-=c6;
      if(c5<0)c5=-c5;
      c5-=c5%2;
      if(c5==0)if(NONULL)goto beg1;
      if(upp)c5=c2+c5;else c5=c2-c5;
      e1.pb(c1);
      e1.pb(c5);

      solver.update(c1,c5);
      }
    if(rr[q1]==2)
      {
      c1=rnd(0,m-1);
      c2=rnd(0,c1);
      c3=rnd(c1+1,m);
      e1.pb(c2);
      e1.pb(c3);
      } 
    test.pb(e1);
    }
  return test;
  }


pair < vector < VI > , VS > gentest(int n,int a,int b)
  {
  vector < VI > t1=test_fast(n,a,b);
  VS a1=solver.doit(t1,4);
  return make_pair(t1,a1);
  }

int gentests(void)
  {
  vector < VI > tt;
  vector < VI > input;
  VS ans;
  VI e1;
  
  e1.pb(18);e1.pb(14);e1.pb(14);tt.pb(e1);e1.clear();
  e1.pb(180);e1.pb(141);e1.pb(149);tt.pb(e1);e1.clear();
  e1.pb(1872);e1.pb(1412);e1.pb(555);tt.pb(e1);e1.clear();
  e1.pb(1998);e1.pb(1111);e1.pb(888);tt.pb(e1);e1.clear();
  e1.pb(2000);e1.pb(1000);e1.pb(1000);tt.pb(e1);e1.clear();
  e1.pb(1996);e1.pb(1400);e1.pb(600);tt.pb(e1);e1.clear();
  e1.pb(1888);e1.pb(1453);e1.pb(476);tt.pb(e1);e1.clear();
  e1.pb(1988);e1.pb(927);e1.pb(811);tt.pb(e1);e1.clear();
  
  e1.pb(97888);e1.pb(1453);e1.pb(476);tt.pb(e1);e1.clear();
  e1.pb(98988);e1.pb(927);e1.pb(811);tt.pb(e1);e1.clear();
  e1.pb(99872);e1.pb(1412);e1.pb(555);tt.pb(e1);e1.clear();
  e1.pb(96998);e1.pb(1111);e1.pb(888);tt.pb(e1);e1.clear();
  e1.pb(92000);e1.pb(1000);e1.pb(1000);tt.pb(e1);e1.clear();
  e1.pb(95996);e1.pb(1400);e1.pb(600);tt.pb(e1);e1.clear();
  
  
  e1.pb(97888);e1.pb(34593);e1.pb(64716);tt.pb(e1);e1.clear();
  e1.pb(98988);e1.pb(59277);e1.pb(38112);tt.pb(e1);e1.clear();
  e1.pb(99872);e1.pb(44162);e1.pb(55535);tt.pb(e1);e1.clear();
  e1.pb(96998);e1.pb(51151);e1.pb(48848);tt.pb(e1);e1.clear();
  e1.pb(92000);e1.pb(60040);e1.pb(39960);tt.pb(e1);e1.clear();
  e1.pb(95996);e1.pb(74030);e1.pb(25060);tt.pb(e1);e1.clear();
  
  int c1=0;
  input.resize(14);
  input[c1].pb(16);input[c1].pb(13);c1++;
  input[c1].pb(2);input[c1].pb(3);input[c1].pb(12);c1++;
  input[c1].pb(1);input[c1].pb(9);input[c1].pb(5);c1++;
  input[c1].pb(1);input[c1].pb(9);input[c1].pb(1);c1++;
  input[c1].pb(2);input[c1].pb(6);input[c1].pb(11);c1++;
  input[c1].pb(1);input[c1].pb(6);input[c1].pb(6);c1++;
  input[c1].pb(1);input[c1].pb(5);input[c1].pb(1);c1++;
  input[c1].pb(2);input[c1].pb(0);input[c1].pb(16);c1++;
  input[c1].pb(1);input[c1].pb(8);input[c1].pb(8);c1++;
  input[c1].pb(2);input[c1].pb(0);input[c1].pb(16);c1++;
  input[c1].pb(1);input[c1].pb(8);input[c1].pb(0);c1++;
  input[c1].pb(1);input[c1].pb(4);input[c1].pb(0);c1++;
  input[c1].pb(1);input[c1].pb(12);input[c1].pb(0);c1++;
  input[c1].pb(2);input[c1].pb(8);input[c1].pb(9);c1++;
  
  ans=solver.doit(input,4);
  
  tests.pb(make_pair(input,ans));
  
  int q1;
  for(q1=0;q1<20;q1++)
    {
    printf("%d\n",q1);
    input=test_fast(tt[q1][0],tt[q1][1],tt[q1][2]);
    ans=solver.doit(input,4);
    tests.pb(make_pair(input,ans));
    }
  int q2;
  
  for(q1=0;q1<=20;q1++)
    {
    FILE*fn;
    char d[1000];
    sprintf(d,"sredna%d.in",q1);
    fn=fopen(d,"w");
    fprintf(fn,"%d %d\n",tests[q1].first[0][0],tests[q1].first[0][1]);
    for(q2=1;q2<tests[q1].first.sz;q2++)
      fprintf(fn,"%d %d %d\n",tests[q1].first[q2][0],tests[q1].first[q2][1],tests[q1].first[q2][2]);
    fclose(fn);
    
    sprintf(d,"sredna%d.out",q1);
    fn=fopen(d,"w");
    for(q2=0;q2<tests[q1].second.sz;q2++)
      fprintf(fn,"%s\n",tests[q1].second[q2].cs);
    fclose(fn);
    }
  
  
  return 0;
  }


int main()
  {
  //solveinputfile("c:\\in.txt");
  int tt1,t2;
  vector < VI > t1=test_fast(100,18,11);
  
  tt1=clock();
  VS ans=solver.doit(t1,4);
  t2=clock();
  
  printf("%lf\n",(t2-tt1+0.0)/CLOCKS_PER_SEC);
  gentests();
  return 0;}
  
